using System;
using System.Windows.Forms;

namespace Datagrid_Extensibility
{
	
	public class CDataGridComboBoxColumn : DataGridTextBoxColumn
	{
		#region Fields
		public ComboBox cbo;
		private CurrencyManager cur;
		private int iRow;
		private bool bEditing = false;
		#endregion

		#region Constructor
		public CDataGridComboBoxColumn()
		{
			cbo = new ComboBox();
			cbo.DropDownStyle = ComboBoxStyle.DropDownList;
			#region Add Handles
			cbo.Leave += new EventHandler(this.LeaveComboBox);
			cbo.SelectionChangeCommitted += new EventHandler(this.ChangeCommitted);
			//VB Code
			//AddHandler cbo.Leave AddressOf(this.LeaveComboBox)
			//AddHandler cbo.SelectionChangeCommitted AddressOf(this.ChangeCommitted)
			#endregion

		}
		#endregion

		#region Events
		private void LeaveComboBox(object sender, EventArgs e)
		{
			if(bEditing)
			{
				this.SetColumnValueAtRow(cur,iRow,cbo.Text);
				bEditing = false;
				Invalidate();
			}
		}

		private void ChangeCommitted(object sender, EventArgs e)
		{
			bEditing = true;
			base.ColumnStartedEditing((Control)sender);
		}
		#endregion

		#region Overrides

		protected override void Edit(CurrencyManager source, int rowNum, System.Drawing.Rectangle bounds, bool readOnly, string instantText, bool cellIsVisible)
		{
			base.Edit(source,rowNum,bounds,ReadOnly,instantText,cellIsVisible);
			
			iRow = rowNum;
			cur = source;

			cbo.Parent = this.TextBox.Parent;
			cbo.Location = this.TextBox.Location;
			cbo.Size = new System.Drawing.Size(this.TextBox.Width,this.TextBox.Height);
			cbo.Text = this.TextBox.Text;

			this.TextBox.Visible = false;
			cbo.Visible = true;
			cbo.BringToFront();
			cbo.Focus();

		}

		protected override bool Commit(CurrencyManager dataSource, int rowNum)
		{
			if (bEditing)
			{
				bEditing = false;
				this.SetColumnValueAtRow(cur,iRow,cbo.Text);
			}
			return true;
		}

		#endregion
	}
}
